﻿using System;
using System.Net;
using System.Windows;
using System.Windows.Controls;
using System.Windows.Documents;
using System.Windows.Ink;
using System.Windows.Input;
using System.Windows.Media;
using System.Windows.Media.Animation;
using System.Windows.Shapes;
using System.Windows.Media.Effects;

namespace PerlinNoiseShader.DisplacementMapFilter
{
    public class DisplacementMapFilter:ShaderEffect
    {
        public static readonly DependencyProperty scaleXYProperty = DependencyProperty.Register("scaleXY", typeof(Size), typeof(DisplacementMapFilter), new PropertyMetadata(new Size(1, 1), PixelShaderConstantCallback(0)));
        public static readonly DependencyProperty sourceImageProperty = ShaderEffect.RegisterPixelShaderSamplerProperty("sourceImage", typeof(DisplacementMapFilter), 0);
        public static readonly DependencyProperty displacementImageProperty = ShaderEffect.RegisterPixelShaderSamplerProperty("displacementImage", typeof(DisplacementMapFilter), 1);
        public DisplacementMapFilter()
        {
            Uri u = new Uri(@"/PerlinNoiseShader;component/DisplacementMapFilter/DisplacementShader.ps", UriKind.Relative);
            this.PixelShader = new PixelShader() { UriSource = u };
            UpdateShaderValue(scaleXYProperty);
            UpdateShaderValue(sourceImageProperty);
            UpdateShaderValue(displacementImageProperty);
        }

        public Size scaleXY
        {
            get { return (Size)GetValue(scaleXYProperty); }
            set { SetValue(scaleXYProperty, value); }
        }

        public Brush sourceImage
        {
            get { return (Brush)GetValue(sourceImageProperty); }
            set { SetValue(sourceImageProperty, value); }
        }

        public Brush displacementImage
        {
            get { return (Brush)GetValue(displacementImageProperty); }
            set { SetValue(displacementImageProperty, value); }
        }


    }
}
